/*
 * File: Page0.java
 * Project: Així es juga, es.aranova.mhp.apps.aixiesjuga;
 * Revision: 1.0
 * Date: 23/03/08 16:31
 *
 * Copyright 2006 ARANOVA.
 *
 * All rights reserved. Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package es.aranova.mhp.apps.aixiesjuga;

import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import es.aranova.mhp.base.PageContainer;
import es.aranova.mhp.base.controls.AppMenu;
import es.aranova.mhp.base.controls.MenuInfo;
import es.aranova.mhp.base.controls.MenuItemBox;
import es.aranova.mhp.base.controls.TextBox;
import es.aranova.mhp.base.enums.TypeMenu;

public class Page0 extends PageContainer implements KeyListener { 
	private AppMenu[] _menus = new AppMenu[2];
	private TextBox _text; 
	private int _menuSel;
	private final MenuInfo[] _menusInfo;

	public Page0() {
		super();
		_menusInfo = new MenuInfo[6];
		_menusInfo[0] = new MenuInfo("Inici", "", "", "es.aranova.mhp.apps.aixiesjuga.Page6");
		_menusInfo[1] = new MenuInfo("Repartir", "", "", "es.aranova.mhp.apps.aixiesjuga.Page5");
		_menusInfo[2] = new MenuInfo("Jugar", "", "", "es.aranova.mhp.apps.aixiesjuga.Page4");
		_menusInfo[3] = new MenuInfo("Arreplegar", "", "", "es.aranova.mhp.apps.aixiesjuga.Page3");
		_menusInfo[4] = new MenuInfo("Comptar", "", "", "es.aranova.mhp.apps.aixiesjuga.Page2");
		_menusInfo[5] = new MenuInfo("Guanyar", "", "", "es.aranova.mhp.apps.aixiesjuga.Page1");
	}
	public String getTemplate() {
		return "es.aranova.mhp.apps.aixiesjuga.templateazul";
	}
	protected void init() {
		int borderX = 10;
		int borderY = 11;
		_menus[0] = new AppMenu(6,35,11,240,getHeight() - 130, TypeMenu.SIMPLE);

		for (int i = 0; i < _menusInfo.length; i++) {
			_menus[0].setLabel(i,_menusInfo[i].getNombre(), _menusInfo[i].getDescripcion());
		}

		_menus[1] = new AppMenu(1,getWidth() - 40, getHeight() - 40, 20, 20, TypeMenu.IMAGE);
		_menus[1].setLabel(0,"Back", "", Toolkit.getDefaultToolkit().getImage("res/tasto_6_architetto_franc_01.png"));
		add(_menus[0]);
		add(_menus[1]);
		_text = new TextBox(290+borderX,borderY,405-borderX,351-borderY);
		add(_text);
		reset();
	}

	protected void reset() {
		_menuSel = 0;
		setMenuActive();
	}

	private void update() {
		_text.setText(((MenuItemBox)_menus[_menuSel].getComponent(_menus[_menuSel].getFocused())).getDescription());
	}

	public void setVisible(boolean b) {
		_menus[0].setVisible(b);
		_menus[1].setVisible(b);
		_text.setVisible(b);
		super.setVisible(b);
	}

	public void keyTyped(KeyEvent e) {
	}

	public void keyPressed(KeyEvent e) {
		if (getActualPage() != null) {
			getActualPage().keyPressed(e);
			return;
		}
		int keyCode = e.getKeyCode();
		switch (keyCode) {
		case KeyEvent.VK_UP:
			e.consume();
			_menus[_menuSel].focusUp();
			update();
			break;
		case KeyEvent.VK_DOWN:
			e.consume();
			_menus[_menuSel].focusDown();
			update();
			break;
			// Pressing enter or right key activates the selected function.
		case KeyEvent.VK_ENTER:
			e.consume();
			switch (_menuSel) {
			case 0:
				goTo(_menusInfo[_menus[_menuSel].getFocused()].getClase());
				break;
			case 1:
				goBack();
				break;
			}
			break;
		case KeyEvent.VK_RIGHT:
			e.consume();
			_menuSel++;
			if (_menuSel >= _menus.length) {
				_menuSel = 0;
			}
			setMenuActive();
			break;
		case KeyEvent.VK_LEFT:
			e.consume();
			_menuSel--;
			if (_menuSel < 0) {
				_menuSel = _menus.length - 1;
			}
			setMenuActive();
			break;
		default:
			break;
		}
	}

	private void setMenuActive() {
		for (int i = 0; i < _menus.length; i++) {
			if (i == _menuSel) {
				_menus[i].setForceFocus(0);
			} else {
				_menus[i].setForceFocus(-1);
			}
		}
		update();
	}

	public void keyReleased(KeyEvent e) {
	}
}