package es.aranova.mhp.base.controls;
/************************************************************
 * The MapGet example application.
 * Class EditableTextBox.
 * - A class for showing and editing text. 
 *
 * Niklas Hagstr�m		
 * Turku Centre for Computer Science - http://www.tucs.fi/
 * September, 2004
 * 
 ************************************************************
 */
import java.awt.*;

public class EditableTextBox extends Component {

	private int width = 0;
	private int height = 0;
	
	private String editStr = null; // The currently edited text
	private String nullStr = null; // The text shown if there's no editStr present
	private char pendingChar = 0;  // An character which has not yet been added to editStr
	
	private boolean focused = false;
	private boolean editActive = false;
	
	// Create the component. 
	public EditableTextBox(String nullStr, int width) {
		setSize(width,45);
		this.nullStr = nullStr;
		this.width = width;
		this.height = 45;
	}
	
	// Paint the component.
	public void paint(Graphics g) {
		if (focused) {
			g.setColor(Color.yellow);
			g.fillRect(0,0,width,height);
		}
		g.setColor(new Color(0xaa,0xaa,0xaa));
		g.fillRect(2,2,width-4,height-4);
		if ((editStr == null) || ((editStr.length() == 0) && !editActive)) {
			g.setColor(Color.black);
			g.setFont(new Font("Tireasias",Font.PLAIN,30));
			g.drawString(nullStr,10,35);
		} else {
			g.setColor(Color.black);
			g.setFont(new Font("Tireasias",Font.PLAIN,30));
			g.drawString(editStr,10,35);
			if (pendingChar != 0) {
				g.setColor(Color.red);
				FontMetrics fm = g.getFontMetrics();
				g.drawString(String.valueOf(pendingChar),10+fm.stringWidth(editStr),35);
			}
		}
	}
	public void setFocused(boolean b) {
		focused = b;
	}
	// Set the pending character (shown after editStr)
	public void setPending(char c) {
		pendingChar = c;
		repaint();
	}
	// Add the pending character to editStr
	public void addPending() {
		editStr += pendingChar;
		pendingChar = 0;
		repaint();
	}
	// Remove the last character (pending or last of editStr)
	public void backSpace() {
		if (pendingChar != 0) {
			pendingChar = 0;
		} else {
			if (editStr.length()>0) {
				editStr = editStr.substring(0,editStr.length()-1);
			}
		}
		repaint();
	}
	// Add space.
	public void space() {
		if (pendingChar != 0) {
			addPending();
		}
		editStr = editStr + ' ';
	}
	
	// Return the edited string.
	public String getString() {
		return editStr;
	}
	// Set edit mode on/off
	public void setEdit(boolean b) {
		editActive = b;
		if (editStr == null) { editStr = new String(); }
	}
}
	