package es.aranova.mhp.base.controls;
import java.awt.*;

public class TextBox extends Component {

	private String boxText = "";

	private int boxX = 0;
	private int boxY = 0;
	private int boxWidth = 0;
	private int boxHeight = 0;
	
	public TextBox(int x,int y,int width,int height) {
		super();
		setLocation(x,y);
		setSize(width,height);
		boxX = x;
		boxY = y;
		boxWidth = width;
		boxHeight = height;
	}

	public void setText(String s) {
		boxText = s;
	}
	
	// Paint text box. 
	public void paint(Graphics g) {
		// TODO: will misbehave if too small
		/*g.setColor(Color.black);
		g.fillRect(0,0,boxWidth,boxHeight);*/

		/*g.setColor(new Color(0x3f,0x7f,0x7f));
		g.fillRect(2,2,boxWidth-4,boxHeight-4);*/
				
		// Write text into box (with word wrapping)
		int textWidthMax = boxWidth-20;
		
		String lineText = "";
		g.setFont(new Font("Tireasias",Font.PLAIN,25));
		g.setColor(Color.white);
		FontMetrics fm = g.getFontMetrics();
		int lineCharPos = 0;
		int lineWidth = 0;
		int lineYCoord = boxY+fm.getHeight();
		int lastSpace = 0;
		for (int p=0;p<boxText.length();p++) {
			if (boxText.charAt(p)==' ') {
				lastSpace = lineCharPos;
			}
			lineWidth += fm.charWidth(boxText.charAt(p));
			if (lineWidth>textWidthMax) {
				g.drawString(lineText.substring(0,lastSpace),10,lineYCoord);
				lineYCoord += 35;
				if (lastSpace<lineText.length()-1) {
					lineText = lineText.substring(lastSpace+1)+String.valueOf(boxText.charAt(p));
				} else {
					lineText = String.valueOf(boxText.charAt(p));
				}
				lineWidth = fm.stringWidth(lineText);
				lineCharPos = lineText.length();
			} else {
				lineText += String.valueOf(boxText.charAt(p));
				lineCharPos++;
			}
			if (p==boxText.length()-1) {
				// Last iteration
				g.drawString(lineText,10,lineYCoord);
			}
		}	
	}
}