package es.aranova.mhp.base.controls;
/************************************************************
 * The MapGet example application.
 * Class AppMenu.
 * - Creates a menu with a number of items to choose from.
 *
 * Niklas Hagstr�m		
 * Turku Centre for Computer Science - http://www.tucs.fi/
 * September, 2004
 * 
 ************************************************************
 */
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Image;


public class AppMenu extends Container {
	private static final long serialVersionUID = 1L;
	private int items = 0;
	private int width = 0;
	private int height = 0;

	private int focusedItem = 0;

	// The AppMenu is initialized with the number of items, position and size. Won't work
	// properly if made too small.
	public AppMenu(int numOfItems, int xPos, int yPos, int menuWidth, int menuHeight, int type) {
		super();

		items = numOfItems;
		width = menuWidth;
		height = menuHeight;

		setSize(width,height);
		setLocation(xPos,yPos);

		int itemHeight = height/items;
		int boxSizeX = width;
		int boxSizeY = itemHeight-4;
		// The AppMenu is made of a number of MenuItemBox:es which are created here.
		for (int i=0;i<items;i++) {
			MenuItemBox tempBox = new MenuItemBox(0,i*itemHeight+2,boxSizeX,boxSizeY, type);
			tempBox.setVisible(true);
			tempBox.setSize(boxSizeX,boxSizeY);
			add(tempBox);
		}
		((MenuItemBox)getComponent(0)).setFocused(true);
	}

	public void paint(Graphics g) {
		// Just call the super class (Container) paint method for painting
		// the MenuItemBox:es.
		super.paint(g);
	}
	
	// Set label of box (selection) i.
	public void setLabel(int i, String s, String description) {
		getComponent(i).setName(s);
		((MenuItemBox)getComponent(i)).setDescription(description);
	}
	public void setLabel(int i, String s, String description, Image image) {
		getComponent(i).setName(s);
		((MenuItemBox)getComponent(i)).setDescription(description);
		((MenuItemBox)getComponent(i)).setImage(image);
	}

	public void focusUp() {
		focusedItem = (focusedItem+items-1) % items;
		updateFocus();
	}
	
	public void focusDown() {
		focusedItem = (focusedItem+1) % items;
		updateFocus();
	}
	
	private void updateFocus() {
		for (int i=0;i<items;i++) {
			((MenuItemBox)getComponent(i)).setFocused(false);
		}
		if (focusedItem != -1) {
			((MenuItemBox)getComponent(focusedItem)).setFocused(true);
		}
		repaint();
	}

	public void setForceFocus(int i) {
		focusedItem = i;
		updateFocus();
	}

	public void setFocus(int i) {
		focusedItem = i % items;
		updateFocus();
	}

	public int getFocused() {
		return focusedItem;
	}
}