package es.aranova.mhp.base;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.tv.xlet.Xlet;
import javax.tv.xlet.XletContext;
import javax.tv.xlet.XletStateChangeException;

import org.havi.ui.HScene;
import org.havi.ui.HSceneFactory;
import org.havi.ui.HSceneTemplate;

public abstract class MainApp extends PageContainer implements Xlet {
	private static final long serialVersionUID = 1L;
	private static XletContext context; 
	private HScene scene;

	public void initXlet(XletContext ctx) throws XletStateChangeException {
		setName(getAppName());
		this.context = ctx;
		// Get scene
		HSceneFactory factory = HSceneFactory.getInstance();
		HSceneTemplate hst = new HSceneTemplate();
		hst.setPreference(HSceneTemplate.SCENE_SCREEN_DIMENSION, new org.havi.ui.HScreenDimension(1, 1), HSceneTemplate.REQUIRED);
		hst.setPreference(HSceneTemplate.SCENE_SCREEN_LOCATION, new org.havi.ui.HScreenPoint(0, 0), HSceneTemplate.REQUIRED);

		scene = factory.getBestScene(hst);
		scene.setBounds(0,0,720,576);
		scene.setLayout(null);
		scene.setBackgroundMode(HScene.BACKGROUND_FILL);
		scene.add(this);
		scene.addKeyListener((KeyListener)this);

		this.setSize(scene.getSize());
		scene.setVisible(false);

		goTo(getInit());
		repaint();
	}

	/**
	 * @return Pagina de inicio.
	 */
	public abstract String getInit();
	protected abstract String getAppName();

	public void startXlet() throws XletStateChangeException {
		validate();
		scene.setVisible(true);
		scene.requestFocus();
	}

	public void pauseXlet() {
		scene.setVisible(false);
	}

	public void destroyXlet(boolean unconditional) {
		if (scene != null) {
			removeKeyListener(this);
			scene.remove(this);
			scene.setVisible(false);
			HSceneFactory.getInstance().dispose(scene);
			scene = null;
		}
		context.notifyDestroyed();
	}

	public void keyPressed(KeyEvent e) {
		if (getActualPage() != null) {
			getActualPage().keyPressed(e);
		}
		if (!e.isConsumed()) {
			System.out.println(e.getKeyCode());
			if ((e.getKeyCode() == KeyEvent.VK_ESCAPE)) {
				destroyXlet(true);
			}
		}
	}

	public void keyReleased(KeyEvent e) {
	}
	public void keyTyped(KeyEvent e) {
	}
	protected void init() {
	}
	protected void reset() {
	}

	/* (non-Javadoc)
	 * @see es.aranova.mhp.base.PageContainer#getTemplate()
	 */
	public String getTemplate() {
		return null;
	}
}
